import { LocationStrategy } from '@angular/common';
import { Injectable } from '@angular/core';
import { ActivatedRouteSnapshot, CanActivate, Router, RouterStateSnapshot } from '@angular/router';
import { AuthenticationResponse } from '../../authenticate/authenticate';
import { AuthenticationService } from '../../services/authenticate.service';
import { CredentialService } from '../../services/credential.service';
import { FormConstants } from '../../utils/enums';
import { ButtonManagementService } from '../../services/button-management.service';


@Injectable(
    { providedIn: 'root' }
)
export class AuthenticationGuard implements CanActivate {

    constructor(private router: Router, private authService: AuthenticationService, private location: LocationStrategy, private credentialService: CredentialService,private buttonManagementService: ButtonManagementService) { }

    canActivate(route: ActivatedRouteSnapshot, state: RouterStateSnapshot) {
        if (typeof window !== 'undefined' && window.localStorage) {
            let data = JSON.parse(window.localStorage.getItem('user') || '{}') as AuthenticationResponse;
            let permission = JSON.parse(window.localStorage.getItem('permission') || '[]');
            if (this.authService.isAuthenticated()) {  
                this.credentialService.setPorOrgacode(window.localStorage.getItem(FormConstants.POR_ORGACODE) || '');
                this.credentialService.setUserId(window.localStorage.getItem(FormConstants.USER_ID) || '');
                this.credentialService.setPassword(window.localStorage.getItem(FormConstants.PASSWORD) || '');
                this.credentialService.setToken(data.token);
                this.credentialService.setUserType(data.userType);
                this.credentialService.setPermission(permission);
                this.buttonManagementService.setButtonPermissions(this.credentialService.getPermission(), this.authService.isSuperAdminUser());   
                this.authService.onAuthenticationComplete.next(true);
                return true;
            } else {
                this.authService.logout();
                return false;
            }
        }
        return false;
    }

}